//+------------------------------------------------------------------+
//|                                               Divergence RSi.mq4 |
//|                                                     Lionel HOUBA |
//+------------------------------------------------------------------+
//|                                                    HOUBA trading |
//+------------------------------------------------------------------+
#property copyright "HOUBA trading."
#property link      "HOUBA trading."

//---- input parameters

extern double lotsize             = 0.1;
extern double MAXORDERS           = 1;
int ticket;
extern double fastMovingPeriod    = 5;
extern double fastmovingshift     = 0;
extern double RSI_value           = 14;
extern double hour_start          = 0;
extern double hour_end            = 24;
extern double stop_loss           = 0.015;
extern double take_profit         = 0.015;
double RSI;

return;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
//----
   return(0);
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
   int start()
  {
//---- go trading only for first tiks of new bar

   if(Volume[0]>1 ) return;
    
//---- BUY CONDITIONS-------------------------------------------------     

//----definition of RSI :

   RSI=(iRSI(NULL,0,RSI_value,PRICE_OPEN,0));
   
//---- limitation of the number of open positions  

   if(OrdersTotal() < MAXORDERS)

//---- check trading hours GMT

   if (Hour()>= hour_start)
   if (Hour()<= hour_end) 
     
//---- if the MA decreases :
   
   if (iMA(NULL,0,fastMovingPeriod,fastmovingshift,MODE_EMA,PRICE_OPEN,1)
   >iMA(NULL,0,fastMovingPeriod,fastmovingshift,MODE_EMA,PRICE_OPEN,0))
   
//---- and if the RSI increases and then creates a divergence with the MA :

   if(iRSI(NULL,0,RSI_value,PRICE_OPEN,1)<iRSI(NULL,0,RSI_value,PRICE_OPEN,0))

//---- and if the RSI is over 70

   if (RSI>=70)
   
   //----send the order buy (long)  
   
   ticket=OrderSend(Symbol(),OP_BUY,lotsize,Ask,3,Open[0]-stop_loss,Open[0]+take_profit,"",0,0,Green);
  
//---- close open position buy (long) if the MA increases
 
   if (iMA(NULL,0,fastMovingPeriod,fastmovingshift,MODE_EMA,PRICE_OPEN,1)
   <iMA(NULL,0,fastMovingPeriod,fastmovingshift,MODE_EMA,PRICE_OPEN,0))

   if (ticket>0)
   
   if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
   
   OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
         
  
  
//---- SELL CONDITIONS------------------------------------ 

//----definition of RSI :

   RSI=(iRSI(NULL,0,RSI_value,PRICE_OPEN,0));
   
//---- limitation of the number of open positions 
 
   if(OrdersTotal() < MAXORDERS)    
   
//---- check trading hours GMT

   if (Hour()>= hour_start)
   if (Hour()<= hour_end) 

//---- if the MA increases

   if (iMA(NULL,0,fastMovingPeriod,fastmovingshift,MODE_EMA,PRICE_OPEN,1)
   <iMA(NULL,0,fastMovingPeriod,fastmovingshift,MODE_EMA,PRICE_OPEN,0))
   
//---- and if the RSI decrease and then creates a divergence with the MA : 

   if(iRSI(NULL,0,RSI_value,PRICE_OPEN,1)>iRSI(NULL,0,RSI_value,PRICE_OPEN,0)) 
   
//---- and if the RSI is under 30

   if (RSI<=30)
  
//----send an order sell  
   
   ticket=OrderSend(Symbol(),OP_SELL,lotsize,Bid,3,Open[0]+stop_loss,Open[0]-take_profit,"",0,0,Green);
  
//---- close open position sell
   
   if (iMA(NULL,0,fastMovingPeriod,fastmovingshift,MODE_EMA,PRICE_OPEN,1)
   >iMA(NULL,0,fastMovingPeriod,fastmovingshift,MODE_EMA,PRICE_OPEN,0))
  
   if (ticket>0)
   
   if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
  
   OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
   
  
   
    }

